.include "include/asm.inc"

.text

.code32
.globl entry
entry: 
        movl (ds_magic),%eax
        cmp $DS_MAGIC,%eax
        je ds_ok
        movw $0x9F44,(0xB8000)
ds_no:	jmp ds_no

ds_ok: 
        lgdt (gdt_ptr)

        mov $LINEAR_DATA_SEL,%eax
        movw %ax,%ds
        movw %ax,%es
        movw %ax,%ss
        movw %ax,%fs
        movw %ax,%gs
        jmp sbat
sbat: 

.extern  bss, end
        mov $bss,%edi
        mov $end,%ecx
        subl %edi,%ecx
        xorl %eax,%eax
        rep
        stosb

        mov $Stack,%esp
.extern main
        call main               
right:    
    jmp right

##############################################################################
# Multiboot header for GRUB bootloader. This must be in the first 8K
# of the kernel file. We use the aout kludge so it works with ELF,
# DJGPP COFF, Win32 PE, or other formats.
##############################################################################
.align 4
mboot: 

# these are in the linker script file
.extern code, bss, end
.long MULTIBOOT_HEADER_MAGIC
.long MULTIBOOT_HEADER_FLAGS
.long MULTIBOOT_CHECKSUM

# aout kludge. These must be PHYSICAL addresses
.long mboot
.long code
.long bss
.long end
.long entry

##############################################################################

.data

ds_magic: 
.long DS_MAGIC


gdt: 
# нулевой дескриптор
        .word 0                 # limit 15:0
        .word 0                 # base 15:0
        .byte 0                 # base 23:16
        .byte 0                 # type
        .byte 0                 # limit 19:16, flags
        .byte 0                 # base 31:24
# неиспользуемый дескриптор
        .word 0
        .word 0
        .byte 0
        .byte 0
        .byte 0
        .byte 0
gdt_01:
.set            LINEAR_DATA_SEL, gdt_01-gdt
        .word 0xFFFF
        .word 0
        .byte 0
        .byte 0x92              # present, ring 0, data, expand-up, writable
        .byte 0xCF              # page-granular (4 gig limit), 32-bit
        .byte 0
gdt_02:
.set            LINEAR_CODE_SEL, gdt_02-gdt
        .word 0xFFFF
        .word 0
        .byte 0
        .byte 0x9A              # present,ring 0,code,non-conforming,readable
        .byte 0xCF              # page-granular (4 gig limit), 32-bit
        .byte 0
gdt_end: 

gdt_ptr: 
.word gdt_end - gdt - 1
.long gdt

##############################################################################

.section .bss
.lcomm Stack, 1024*4             # резерв 4 кб под стек
  


